#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;
int INF = -1e9, n;
vector <int> tree(8e5), h(2e5 + 1);


void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = l;
        return;
    }
    int m = (r + l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    if (h[tree[2 * v + 1]] > h[tree[2 * v + 2]]) {
        tree[v] = tree[2 * v + 1];
    } else {
        tree[v] = tree[2 * v + 2];
    }
}

int get(int v, int l, int r, int l0, int r0) {
    if (l >= r0 || l0 >= r) {
        return 2e5;
    }
    if (l >= l0 && r <= r0) {
        return tree[v];
    }
    int m = (r + l) / 2;
    int s1 = get(2 * v + 1, l, m, l0, r0);
    int s2 = get(2 * v + 2, m, r, l0, r0);
    if (h[s1] > h[s2]) {
        return s1;
    } else {
        return s2;
    }
}

long long solve(int l, int r, vector<long long> &c){
    if (r - l == 1) return c[l];
    int maxIdx = get(0, 0, n, l, r);
    if (maxIdx == l || maxIdx == r - 1) return c[maxIdx];
    long long s1 = solve(l, maxIdx, c), s2 = solve(maxIdx + 1, r, c);
    return min(s1, s2) + c[maxIdx];
}

int main() {
    h[200000] = INF;
    cin >> n;
    vector<long long> c(n, 0);
    for (int i = 0; i < n; i++){
        cin >> h[i];
    }
    for (int i = 0; i < n; i++){
        cin >> c[i];
    }
    build(0, 0, n);
    cout << solve(0, n, c);
}