#include <iostream>
#include <cmath>
#include <map>
#include <algorithm>
#include <vector>
#include <set>
#include <string>

using namespace std;
vector<int> h;
vector<long long> c;

int n;
vector<pair<int, int>> tree;

void build (int i, int l, int r) {
    if (r - l == 1) {
        tree[i] = {h[l], l};
        return;
    }
    if (r - l < 1) {
        return;
    }
    int m = (l + r) / 2;
    build(2 * i + 1, l, m);
    build(2 * i + 2, m, r);
    tree[i] = max(tree[2 * i + 1], tree[2 * i + 2]);
}

pair<int, int> sum (int i, int ql, int qr, int l, int r) {
    if (l >= ql && r <= qr) {
        return tree[i];
    }
    if (l >= qr || r <= ql) {
        return {-1, -1};
    }
    int m = (l + r) / 2;
    return max(sum(2 * i + 1, ql, qr, l, m), sum(2 * i + 2, ql, qr, m, r));
}

long long rec(int l, int r)
{
    if(r - l <= 0)
    {
        return c[l];
    }
    pair<int, int> max = sum(0, l, r + 1, 0, n);
    if(max.second == l)
    {
        return c[l];
    }
    if(max.second == r)
    {
        return c[r];
    }
    return c[max.second] + min(rec(l, max.second - 1), rec(max.second + 1, r ));
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cin >> n;
    h.resize(n);
    c.resize(n);
    tree.resize(4 * n, {0, 0});
    for (int i = 0; i < n; i++) {
        cin >> h[i];
    }
    for(int i = 0; i < n; i++)
    {
        cin >> c[i];
    }
    build(0, 0, n);
    cout << rec(0, n - 1);
}
