#ifdef LOCAL
#define _GLIBCXX_DEBUG 1
#define nl endl
#else
#define nl '\n'
#pragma GCC optimize("Ofast")
#endif

#include<bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

template<typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define forn(i, n) for(decltype(n) i = 0; i < n; i++)
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()
#define _ <<" "<<
#define pb push_back
#define eb emplace_back
#define ll long long
#define ld long double
#define ull unsigned long long

struct node {
    ll l, r;

    int type, nxt = -1, prev = -1;

    node() = default;

    node(ll l, ll r, int type = 0) : l(l), r(r), type(type) {}
};

vector<node> s;

int new_node(ll l, ll r, int type = 0) {
    s.emplace_back(l, r, type);
    return s.size() - 1;
}

void connect(int a, int b) {
    if (a != -1) s[a].nxt = b;
    if (b != -1) s[b].prev = a;
}

struct cmp {
    bool operator()(const int &a, const int &b) const {
        int l1 = s[a].r - s[a].l + 1, l2 = s[b].r - s[b].l + 1;
        return tie(l2, s[a].l) < tie(l1, s[b].l);
    }
};

void solve() {
    ll n, q;
    cin >> n >> q;

    int gl = new_node(-1, -1, 1), gr = new_node(n, n, 1);
    int tmp = new_node(0, n - 1);
    connect(gl, tmp), connect(tmp, gr);

    int cur_p = 0;
    unordered_map<int, int> person;


    set<int, cmp> st;
    st.emplace(tmp);

    while (q--) {
        string ss;
        cin >> ss;
        char c = ss[0];
        if (c == '+') {
            auto v = *st.begin();
            st.erase(st.begin());
            ll l = s[v].l, r = s[v].r;
            if (s[v].prev == gl) {
                int p = new_node(0, 0, 1);
                connect(gl, p);
                s[v].l++;
                if (s[v].r - s[v].l > 0) {
                    connect(p, v);
                    st.emplace(v);
                } else {
                    connect(p, s[v].nxt);
                }
                st.emplace(p);
                person[cur_p++] = p;
                cout << s[p].l + 1 << nl;
            } else if (s[v].nxt == gr) {
                int p = new_node(n - 1, n - 1, 1);
                connect(p, gr);
                s[v].r--;
                if (s[v].r - s[v].l > 0) {
                    connect(v, p);
                    st.emplace(v);
                } else {
                    connect(s[v].prev, p);
                }
                st.emplace(p);
                person[cur_p++] = p;
                cout << s[p].l + 1 << nl;
            } else {
                int pos = (s[v].l + s[v].r) / 2;
                int p = new_node(pos, pos, 1);
                s[v].r = pos - 1;
                int R = new_node(pos + 1, s[v].r);
                if (s[v].r - s[v].l > 0) {
                    connect(v, p);
                    st.emplace(v);
                } else {
                    connect(s[v].prev, p);
                }
                if (s[R].r - s[R].l > 0) {
                    connect(p, R);
                    connect(R, s[v].nxt);
                    st.emplace(R);
                } else {
                    connect(p, s[v].nxt);
                }
                st.emplace(p);
                person[cur_p++] = p;
                cout << s[p].l + 1 << nl;
            }
        } else {
            int x = stoi(ss.substr(1, ss.size() - 1));
            int ptr = person[x - 1];
            int nx = s[ptr].nxt, pr = s[ptr].prev;
            if (!s[nx].type && !s[pr].type) {
                st.extract(nx);
                st.extract(pr);
                s[pr].r = s[nx].r;
                st.emplace(pr);
                connect(pr, s[nx].nxt);
            } else if (!s[pr].type) {
                st.extract(pr);
                s[pr].r++;
                connect(pr, nx);
                st.emplace(pr);
            } else if (!s[nx].type){
                st.extract(nx);
                s[nx].l--;
                connect(pr, nx);
                st.emplace(nx);
            }
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);

    int t = 1;
//    cin >> t;
    while (t--) solve();
}