#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

ll slow(ll w, ll h) {
    ll ans = 0;
    vector<pair<ll, ll>> isl = {{h, w}};
    while (!isl.empty()) {
        vector<pair<ll, ll>> isl1;
        for (auto &p: isl) {
            ans += p.first * p.second;
            if (p.first == 1 && p.second == 1) {
                continue;
            }
            if (p.first < p.second) {
                swap(p.first, p.second);
            }
            isl1.emplace_back(p.first / 2, p.second);
            isl1.emplace_back(p.first - (p.first / 2), p.second);
        }
        isl = isl1;
    }
    return ans;
}

ll fast(ll w, ll h) {
    vector<ll> k, m;
    for (ll i = 0; (1 << i) <= w; i++) {
        if ((w >> i) & 1) {
            k.push_back(i);
        }
    }
    for (ll i = 0; (1 << i) <= h; i++) {
        if ((h >> i) & 1) {
            m.push_back(i);
        }
    }
    ll ans = w * h * ((k.size() - 1) + (m.size() - 1));
    for (auto &mi: m) {
        for (auto &ki: k) {
            ans += (1 << (ki + mi)) * (ki + mi + 1);
        }
    }
    return ans;
}

ll improved(ll w, ll h) {
    vector<ll> s(min(w, h) + 1);
    s[1] = 1;
    for (int i = 2; i < s.size(); i++) {
        s[i] = i + s[i - 1] + 1;
    }
    if (w > h) {
        swap(w, h);
    }
    ll ans = w * h;
    while (h > w) {
        h--;
        ans += s[w] + h * w;
    }
    while (h > 1) {
        ans += s[h] + h * (h - 1);
        ans += s[h - 1] + (h - 1) * (h - 1);
        h--;
    }
    return ans;
}

void solve() {
    ll h, w;
    cin >> h >> w;
    cout << improved(w, h);
}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    solve();
}
