#include <bits/stdc++.h>

using ll = long long;
using ld = long double;
using namespace std;

const ll inf = 1e18;
const ll mod = 1e9 + 7;

struct Day {
    int day, w;

    Day() : day(0), w(0) {}

    Day(int day, int w) : day(day), w(w) {}
};

bool operator<(Day &one, Day &two) {
    return one.day < two.day;
}

ld step(ld val, int n) {
    if (n == 0) {
        return 1;
    } else if (n == 1) {
        return val;
    } else if (n % 2 == 1) {
        return step(val, n - 1) * val;
    } else {
        ld res = step(val, n / 2);
        return res * res;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    cout.precision(16);

    ld r;
    int n, m;
    cin >> n >> m >> r;

    vector<Day> d(n);
    vector<ll>srch(n);
    for (int i = 0; i < n; ++i) {
        cin >> d[i].day >> d[i].w;
        srch[i] = d[i].day;
    }

    sort(srch.begin(), srch.end());
    sort(d.begin(), d.end());

    vector<ld> dp(n);
    dp[0] = d[0].w * r;
    for (int i = 1; i < n; ++i) {
        dp[i] = dp[i - 1] * step((1 - r), d[i].day - d[i - 1].day) + d[i].w * r;
    }

    ll index;
    for (int i = 0, q; i < m; ++i) {
        cin >> q;
        index = upper_bound(srch.begin(), srch.end(), q)-srch.begin() - 1;

        if (index < 0) {
            cout << 0 << ' ';
        } else {
            cout << dp[index]*step((1-r), q-d[index].day) << ' ';
        }
    }
}
