/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<int, double> pid;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

int main() {

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    in(int, n, m)
    in(double, r)
    unordered_map<int, double> inc;
    for (int i = 0; i < n; i++) {
        in(int, d)
        in(double, w)
        inc[d] = w;
    }

    vector<pii> queries(m);
    vector<double> answers(m);
    for (int i = 0; i < m; i++) {
        queries[i].second = i;
        cin >> queries[i].first;
    }
    sort(all(queries));

    double value = 0;
    int last_day = 0;
    for (int i = 0; i < m; i++) {
        auto [day, id] = queries[i];
        while (last_day < day) {
            last_day++;
            value *= 1 - r;
            if (inc.count(last_day)) {
                value += r * inc[last_day];
            }
        }
        answers[id] = value;
    }

    cout.precision(12);
    for (int i = 0; i < m; i++) {
        cout << answers[i] << ' ';
    }
    cout << '\n';

}