/*
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned int uint;
typedef pair<int, int> pii;
typedef pair<int, double> pid;

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &p) {
    return in >> p.first >> p.second;
}

template<typename T>
istream &operator>>(istream &in, vector<T> &v) {
    for (auto &item : v)
        in >> item;
    return in;
}

void mcin() {}

template<typename T, typename ...Tail>
void mcin(T &&arg, Tail &&...args) {
    cin >> arg;
    mcin(args...);
}
#define in(type, ...) type __VA_ARGS__; mcin(__VA_ARGS__);

#define all(c) c.begin(), c.end()

double power(double value, int d) {
    if (d == 0) return 1.0;
    if (d == 1) return value;
    double root = power(value, d / 2);
    double result = root * root;
    if (d % 2) result *= value;
    return result;
}

int main() {

    in(int, n, m)
    in(double, r)
    vector<pid> days(n);
    for (int i = 0; i < n; i++) {
        cin >> days[i].first >> days[i].second;
        days[i].second *= r;
    }
    sort(all(days));
    for (int i = 1; i < n; i++) {
        days[i].second += days[i - 1].second * power(1 - r, days[i].first - days[i - 1].first);
    }

    vector<pii> queries(m);
    vector<double> answers(m);
    for (int i = 0; i < m; i++) {
        queries[i].second = i;
        cin >> queries[i].first;
    }
    sort(all(queries));

    int last_day = -1;
    for (int i = 0; i < m; i++) {
        auto [day, id] = queries[i];
        if (day < days[0].first) {
            answers[id] = 0.0;
            continue;
        }
        bool skipped = false;
        while (last_day + 1 < n && days[last_day + 1].first <= day) {
            last_day++;
            skipped = true;
        }
        if (skipped) {
            auto [prev_day, value] = days[last_day];
            answers[id] = value * power(1 - r, day - prev_day);
        } else {
            auto [prev_day, prev_id] = queries[i - 1];
            answers[id] = answers[prev_id] * power(1 - r, day - prev_day);
        }
    }

    cout.precision(12);
    for (int i = 0; i < m; i++) {
        cout << fixed << answers[i] << ' ';
    }
    cout << '\n';

}