"""
    @author: doreshnikov
    Daniil Oreshnikov, ITMO University
"""

from fractions import Fraction

n, m = map(int, input().split())
r = Fraction(input())
days = []
for i in range(n):
    d, w = map(int, input().split())
    days.append((d, w))
queries = list(map(int, input().split()))

events = []
for d, w in days:
    events.append((d, -1, w))
for i, q in enumerate(queries):
    events.append((q, i))


def bin_pow(x: Fraction, deg: int) -> Fraction:
    if deg == 0:
        return Fraction('1.0')
    if deg == 1:
        return x
    root = bin_pow(x, deg // 2)
    root *= root
    return root if deg % 2 == 0 else root * x


events.sort()
answer = [0.0 for _ in range(m)]
value = 0.0
last_day = 0
for e in events:
    value *= bin_pow(Fraction('1.0') - r, e[0] - last_day)
    if e[1] == -1:
        value += e[2] * r
    else:
        answer[e[1]] = float(value)
    last_day = e[0]

print(' '.join(map(str, answer)))
